(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common'], factory) :
	(factory((global['angular-prism'] = {}),global.core,global.common));
}(this, (function (exports,core,common) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PrismComponent = (function () {
    function PrismComponent(elementRef) {
        this.elementRef = elementRef;
    }
    /**
     * @return {?}
     */
    PrismComponent.prototype.onContentChanged = /**
     * @return {?}
     */
    function () {
        this.codeViewChild.nativeElement.innerHTML = this.code ?
            this.encodeEntities(this.code) : this.rawViewChild.nativeElement.innerHTML;
        Prism.highlightElement(this.codeViewChild.nativeElement);
    };
    /**
     * @return {?}
     */
    PrismComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.onContentChanged();
    };
    /**
     * @return {?}
     */
    PrismComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        this.onContentChanged();
    };
    /**
     * @return {?}
     */
    PrismComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.observer = new MutationObserver(this.onContentChanged.bind(this));
        this.observer.observe(this.rawViewChild.nativeElement, {
            'characterData': true,
            'childList': true,
            'subtree': true
        });
    };
    /**
     * @return {?}
     */
    PrismComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.observer) {
            this.observer.disconnect();
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    PrismComponent.prototype.encodeEntities = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return value
            .replace(/&/g, '&amp;')
            .replace(/"/g, '&quot;')
            .replace(/'/g, '&#39;')
            .replace(/</g, '&lt;')
            .replace(/>/g, '&gt;');
    };
    PrismComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'prism',
                    template: "\n    <div hidden #raw style=\"display: none\"><ng-content></ng-content></div>\n    <pre><code class=\"language-{{language}}\" #code></code></pre>\n  "
                },] },
    ];
    /** @nocollapse */
    PrismComponent.ctorParameters = function () { return [
        { type: core.ElementRef, },
    ]; };
    PrismComponent.propDecorators = {
        "language": [{ type: core.Input },],
        "code": [{ type: core.Input },],
        "rawViewChild": [{ type: core.ViewChild, args: ['raw',] },],
        "codeViewChild": [{ type: core.ViewChild, args: ['code',] },],
    };
    return PrismComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PrismModule = (function () {
    function PrismModule() {
    }
    PrismModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule
                    ],
                    declarations: [
                        PrismComponent
                    ],
                    exports: [
                        PrismComponent
                    ]
                },] },
    ];
    /** @nocollapse */
    PrismModule.ctorParameters = function () { return []; };
    return PrismModule;
}());

exports.PrismModule = PrismModule;
exports.PrismComponent = PrismComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
